diff --git a/src/gui/painting/qdrawhelper.cpp b/src/gui/painting/qdrawhelper.cpp
index b3f9fd9..2399acf 100644
--- a/src/gui/painting/qdrawhelper.cpp
+++ b/src/gui/painting/qdrawhelper.cpp
@@ -185,7 +185,7 @@ static const uint *QT_FASTCALL convertToRGB32(uint *buffer, const uint *src, int
 }
 
 template<QImage::Format Format>
-static const QRgba64 *QT_FASTCALL convertToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                  const QPixelLayout *, const QRgb *)
 {
     Q_CONSTEXPR uint redMask = ((1 << redWidth<Format>()) - 1);
@@ -250,7 +250,7 @@ static const uint *QT_FASTCALL convertARGBPMToARGB32PM(uint *buffer, const uint
 }
 
 template<QImage::Format Format>
-static const QRgba64 *QT_FASTCALL convertARGBPMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertARGBPMToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                           const QPixelLayout *, const QRgb *)
 {
     Q_CONSTEXPR uint alphaMask = ((1 << alphaWidth<Format>()) - 1);
@@ -417,7 +417,7 @@ static const uint *QT_FASTCALL convertIndexedToARGB32PM(uint *buffer, const uint
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertIndexedToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertIndexedToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                            const QPixelLayout *, const QRgb *clut)
 {
     for (int i = 0; i < count; ++i)
@@ -467,7 +467,7 @@ static const uint *QT_FASTCALL convertGrayscale8ToRGB32(uint *buffer, const uint
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertAlpha8ToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertAlpha8ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                        const QPixelLayout *, const QRgb *)
 {
     for (int i = 0; i < count; ++i)
@@ -475,7 +475,7 @@ static const QRgba64 *QT_FASTCALL convertAlpha8ToRGB64(QRgba64 *buffer, const ui
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertGrayscale8ToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertGrayscale8ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                            const QPixelLayout *, const QRgb *)
 {
     for (int i = 0; i < count; ++i)
@@ -483,6 +483,30 @@ static const QRgba64 *QT_FASTCALL convertGrayscale8ToRGB64(QRgba64 *buffer, cons
     return buffer;
 }
 
+static Q_DECL_CONSTEXPR uint qt_div_257_floor(uint x) { return  (x - (x >> 8)) >> 8; }
+static Q_DECL_CONSTEXPR uint qt_div_257(uint x) { return qt_div_257_floor(x + 128); }
+
+static const uint *QT_FASTCALL convertGrayscale16ToRGB32(uint *buffer, const uint *src, int count,
+                                                         const QPixelLayout *, const QRgb *)
+{
+    // FIXME: Verify what the fuck I am doing here.
+    for (int i = 0; i < count; ++i) {
+        int green = qt_div_257(src[i]);
+        int red = green; // std::min(std::max(green + (int)((src[i] >> 6) & 3) - 2, 255), 0);
+        int blue = green; // std::min(std::max(green + (int)((src[i] >> 4) & 7) - 4, 255), 0);
+        buffer[i] = qRgb(red, green, blue);
+    }
+    return buffer;
+}
+
+static const QRgba64 *QT_FASTCALL convertGrayscale16ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
+                                                            const QPixelLayout *, const QRgb *)
+{
+    for (int i = 0; i < count; ++i)
+        buffer[i] = QRgba64::fromRgba64(src[i], src[i], src[i], 65535);
+    return buffer;
+}
+
 static const uint *QT_FASTCALL convertARGB32FromARGB32PM(uint *buffer, const uint *src, int count,
                                                          const QPixelLayout *, const QRgb *)
 {
@@ -501,7 +525,7 @@ static const uint *QT_FASTCALL convertRGBA8888PMFromARGB32PM(uint *buffer, const
 
 #ifdef __SSE2__
 template<bool RGBA, bool maskAlpha>
-static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const uint *src, int count)
+static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const quint64 *src, int count)
 {
     const __m128i amask = _mm_set1_epi32(0xff000000);
     int i = 0;
@@ -513,7 +537,9 @@ static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const uint *
         i++;
     }
     for (; i < count-3; i += 4) {
-        __m128i vs = _mm_loadu_si128((const __m128i*)src);
+        __m128 vs1 = _mm_loadu_ps((const float*)src);
+        __m128 vs2 = _mm_loadu_ps((const float*)(src + 2));
+        __m128i vs = _mm_castps_si128(_mm_shuffle_ps(vs1, vs2, _MM_SHUFFLE(2, 0, 2, 0)));
         if (maskAlpha)
             vs = _mm_or_si128(vs, amask);
         src += 4;
@@ -540,7 +566,7 @@ static inline void qConvertARGB32PMToARGB64PM_sse2(QRgba64 *buffer, const uint *
 }
 #endif
 
-static const QRgba64 *QT_FASTCALL convertRGB32ToRGB64(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGB32ToRGB64(QRgba64 *buffer, const quint64 *src, int count,
                                                       const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -552,7 +578,13 @@ static const QRgba64 *QT_FASTCALL convertRGB32ToRGB64(QRgba64 *buffer, const uin
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertARGB32ToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGB64ToRGB64(QRgba64 *, const quint64 *src, int,
+                                                      const QPixelLayout *, const QRgb *)
+{
+    return reinterpret_cast<const QRgba64*>(src);
+}
+
+static const QRgba64 *QT_FASTCALL convertARGB32ToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                           const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -566,7 +598,7 @@ static const QRgba64 *QT_FASTCALL convertARGB32ToARGB64PM(QRgba64 *buffer, const
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertARGB32PMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertARGB32PMToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                             const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -578,7 +610,7 @@ static const QRgba64 *QT_FASTCALL convertARGB32PMToARGB64PM(QRgba64 *buffer, con
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertRGBA8888ToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGBA8888ToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                             const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -592,7 +624,7 @@ static const QRgba64 *QT_FASTCALL convertRGBA8888ToARGB64PM(QRgba64 *buffer, con
     return buffer;
 }
 
-static const QRgba64 *QT_FASTCALL convertRGBA8888PMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertRGBA8888PMToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                              const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -639,7 +671,7 @@ static const uint *QT_FASTCALL convertA2RGB30PMToARGB32PM(uint *buffer, const ui
 
 #ifdef __SSE2__
 template<QtPixelOrder PixelOrder>
-static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const uint *src, int count)
+static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const quint64 *src, int count)
 {
     const __m128i rmask = _mm_set1_epi32(0x3ff00000);
     const __m128i gmask = _mm_set1_epi32(0x000ffc00);
@@ -651,7 +683,9 @@ static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const uint
         i++;
     }
     for (; i < count-3; i += 4) {
-        __m128i vs = _mm_loadu_si128((const __m128i*)src);
+        __m128 vs1 = _mm_loadu_ps((const float*)src);
+        __m128 vs2 = _mm_loadu_ps((const float*)(src + 2));
+        __m128i vs = _mm_castps_si128(_mm_shuffle_ps(vs1, vs2, _MM_SHUFFLE(2, 0, 2, 0)));
         src += 4;
         __m128i va = _mm_srli_epi32(vs, 30);
         __m128i vr = _mm_and_si128(vs, rmask);
@@ -679,7 +713,7 @@ static inline void qConvertA2RGB30PMToARGB64PM_sse2(QRgba64 *buffer, const uint
 #endif
 
 template<QtPixelOrder PixelOrder>
-static const QRgba64 *QT_FASTCALL convertA2RGB30PMToARGB64PM(QRgba64 *buffer, const uint *src, int count,
+static const QRgba64 *QT_FASTCALL convertA2RGB30PMToARGB64PM(QRgba64 *buffer, const quint64 *src, int count,
                                                              const QPixelLayout *, const QRgb *)
 {
 #ifdef __SSE2__
@@ -742,6 +776,24 @@ static const uint *QT_FASTCALL convertGrayscale8FromARGB32PM(uint *buffer, const
     return buffer;
 }
 
+static const uint *QT_FASTCALL convertGrayscale16FromRGB32(uint *buffer, const uint *src, int count,
+                                                           const QPixelLayout *, const QRgb *)
+{
+    for (int i = 0; i < count; ++i)
+        buffer[i] = qGray(src[i]) * 257;
+//        buffer[i] = qGray16(src[i]);
+    return buffer;
+}
+
+static const uint *QT_FASTCALL convertGrayscale16FromARGB32PM(uint *buffer, const uint *src, int count,
+                                                              const QPixelLayout *, const QRgb *)
+{
+    for (int i = 0; i < count; ++i)
+        buffer[i] = qGray(qUnpremultiply(src[i])) * 257;
+//        buffer[i] = qGray16(qUnpremultiply(src[i]));
+    return buffer;
+}
+
 template <QPixelLayout::BPP bpp> static
 uint QT_FASTCALL fetchPixel(const uchar *src, int index);
 
@@ -781,6 +833,26 @@ inline uint QT_FASTCALL fetchPixel<QPixelLayout::BPP32>(const uchar *src, int in
     return reinterpret_cast<const uint *>(src)[index];
 }
 
+template <>
+inline uint QT_FASTCALL fetchPixel<QPixelLayout::BPP64>(const uchar *src, int index)
+{
+    // We have to do the conversion in fetch to fit into a 32bit uint
+    QRgba64 c = reinterpret_cast<const QRgba64 *>(src)[index];
+    return c.toArgb32();
+}
+
+template <QPixelLayout::BPP bpp>
+static quint64 QT_FASTCALL fetchPixel64(const uchar *src, int index)
+{
+    return fetchPixel<bpp>(src, index);
+}
+
+template <>
+quint64 QT_FASTCALL fetchPixel64<QPixelLayout::BPP64>(const uchar *src, int index)
+{
+    return reinterpret_cast<const quint64 *>(src)[index];
+}
+
 template <QPixelLayout::BPP bpp>
 inline const uint *QT_FASTCALL fetchPixels(uint *buffer, const uchar *src, int index, int count)
 {
@@ -795,11 +867,65 @@ inline const uint *QT_FASTCALL fetchPixels<QPixelLayout::BPP32>(uint *, const uc
     return reinterpret_cast<const uint *>(src) + index;
 }
 
-template <QPixelLayout::BPP width> static
+static inline void qConvertRGBA64ToARGB32(uint *buffer, const QRgba64 *src, int count)
+{
+    int i = 0;
+#ifdef __SSE2__
+    if (((uintptr_t)buffer & 0x7) && count > 0) {
+        *buffer++ = (*src++).toArgb32();
+        i++;
+    }
+    const __m128i vhalf = _mm_set1_epi32(0x80);
+    for (; i < count-1; i += 2) {
+        __m128i vs = _mm_loadu_si128((const __m128i*)src);
+        src += 2;
+        vs = _mm_shufflelo_epi16(vs, _MM_SHUFFLE(3, 0, 1, 2));
+        vs = _mm_shufflehi_epi16(vs, _MM_SHUFFLE(3, 0, 1, 2));
+        __m128i v1 = _mm_unpacklo_epi16(vs, _mm_setzero_si128());
+        __m128i v2 = _mm_unpackhi_epi16(vs, _mm_setzero_si128());
+        v1 = _mm_add_epi32(v1, vhalf);
+        v2 = _mm_add_epi32(v2, vhalf);
+        v1 = _mm_sub_epi32(v1, _mm_srli_epi32(v1, 8));
+        v2 = _mm_sub_epi32(v2, _mm_srli_epi32(v2, 8));
+        v1 = _mm_srli_epi32(v1, 8);
+        v2 = _mm_srli_epi32(v2, 8);
+        v1 = _mm_packs_epi32(v1, v2);
+        v1 = _mm_packus_epi16(v1, v1);
+        _mm_storel_epi64((__m128i*)(buffer), v1);
+        buffer += 2;
+    }
+#endif
+    for (; i < count; ++i)
+        *buffer++ = (*src++).toArgb32();
+}
+
+template <>
+inline const uint *QT_FASTCALL fetchPixels<QPixelLayout::BPP64>(uint *buffer, const uchar *src, int index, int count)
+{
+    const QRgba64 *s = reinterpret_cast<const QRgba64 *>(src) + index;
+    qConvertRGBA64ToARGB32(buffer, s, count);
+    return buffer;
+}
+
+template <QPixelLayout::BPP bpp>
+const quint64 *QT_FASTCALL fetchPixels64(quint64 *buffer, const uchar *src, int index, int count)
+{
+    for (int i = 0; i < count; ++i)
+        buffer[i] = fetchPixel64<bpp>(src, index + i);
+    return buffer;
+}
+
+template <>
+const quint64 *QT_FASTCALL fetchPixels64<QPixelLayout::BPP64>(quint64 *, const uchar *src, int index, int)
+{
+    return reinterpret_cast<const quint64 *>(src) + index;
+}
+
+template <QPixelLayout::BPP width>
 void QT_FASTCALL storePixel(uchar *dest, int index, uint pixel);
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP1LSB>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP1LSB>(uchar *dest, int index, uint pixel)
 {
     if (pixel)
         dest[index >> 3] |= 1 << (index & 7);
@@ -808,7 +934,7 @@ inline void QT_FASTCALL storePixel<QPixelLayout::BPP1LSB>(uchar *dest, int index
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP1MSB>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP1MSB>(uchar *dest, int index, uint pixel)
 {
     if (pixel)
         dest[index >> 3] |= 1 << (~index & 7);
@@ -817,23 +943,42 @@ inline void QT_FASTCALL storePixel<QPixelLayout::BPP1MSB>(uchar *dest, int index
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP8>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP8>(uchar *dest, int index, uint pixel)
 {
     dest[index] = uchar(pixel);
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP16>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP16>(uchar *dest, int index, uint pixel)
 {
     reinterpret_cast<quint16 *>(dest)[index] = quint16(pixel);
 }
 
 template <>
-inline void QT_FASTCALL storePixel<QPixelLayout::BPP24>(uchar *dest, int index, uint pixel)
+void QT_FASTCALL storePixel<QPixelLayout::BPP24>(uchar *dest, int index, uint pixel)
 {
     reinterpret_cast<quint24 *>(dest)[index] = quint24(pixel);
 }
 
+template <>
+void QT_FASTCALL storePixel<QPixelLayout::BPP32>(uchar *dest, int index, uint pixel)
+{
+    reinterpret_cast<uint *>(dest)[index] = pixel;
+}
+
+template <>
+void QT_FASTCALL storePixel<QPixelLayout::BPP64>(uchar *dest, int index, uint pixel)
+{
+    QRgba64 p = QRgba64::fromArgb32(pixel);
+    reinterpret_cast<quint64 *>(dest)[index] = p;
+}
+
+template <QPixelLayout::BPP width>
+static void QT_FASTCALL storePixel64(uchar *dest, int index, quint64 pixel)
+{
+    storePixel<width>(dest, index, pixel);
+}
+
 template <QPixelLayout::BPP width>
 inline void QT_FASTCALL storePixels(uchar *dest, const uint *src, int index, int count)
 {
@@ -847,6 +992,19 @@ inline void QT_FASTCALL storePixels<QPixelLayout::BPP32>(uchar *dest, const uint
     memcpy(reinterpret_cast<uint *>(dest) + index, src, count * sizeof(uint));
 }
 
+template <QPixelLayout::BPP width>
+static void QT_FASTCALL storePixels64(uchar *dest, const quint64 *src, int index, int count)
+{
+    for (int i = 0; i < count; ++i)
+        storePixel64<width>(dest, index + i, src[i]);
+}
+
+template <>
+void QT_FASTCALL storePixels64<QPixelLayout::BPP64>(uchar *dest, const quint64 *src, int index, int count)
+{
+    memcpy(reinterpret_cast<quint64 *>(dest) + index, src, count * sizeof(quint64));
+}
+
 // Note:
 // convertToArgb32() assumes that no color channel is less than 4 bits.
 // convertFromArgb32() assumes that no color channel is more than 8 bits.
@@ -941,39 +1099,83 @@ QPixelLayout qPixelLayouts[QImage::NImageFormats] = {
     { 10,  0, 10,  10, 10, 20, 0, 30, false, QPixelLayout::BPP32, convertA2RGB30PMToARGB32PM<PixelOrderRGB>, convertRGB30FromARGB32PM<PixelOrderRGB>, convertRGB30FromRGB32<PixelOrderRGB>, convertA2RGB30PMToARGB64PM<PixelOrderRGB> }, // Format_RGB30
     { 10,  0, 10,  10, 10, 20, 2, 30,  true, QPixelLayout::BPP32, convertA2RGB30PMToARGB32PM<PixelOrderRGB>, convertA2RGB30PMFromARGB32PM<PixelOrderRGB>, convertRGB30FromRGB32<PixelOrderRGB>, convertA2RGB30PMToARGB64PM<PixelOrderRGB> },  // Format_A2RGB30_Premultiplied
     { 0, 0,  0, 0,  0, 0,  8, 0, false, QPixelLayout::BPP8, convertAlpha8ToRGB32, convertAlpha8FromARGB32PM, 0, convertAlpha8ToRGB64 }, // Format_Alpha8
-    { 0, 0,  0, 0,  0, 0,  0, 0, false, QPixelLayout::BPP8, convertGrayscale8ToRGB32, convertGrayscale8FromARGB32PM, convertGrayscale8FromRGB32, convertGrayscale8ToRGB64 } // Format_Grayscale8
+    { 0, 0,  0, 0,  0, 0,  0, 0, false, QPixelLayout::BPP8, convertGrayscale8ToRGB32, convertGrayscale8FromARGB32PM, convertGrayscale8FromRGB32, convertGrayscale8ToRGB64 }, // Format_Grayscale8
+    { 0, 0,  0, 0,  0, 0,  0, 0, false, QPixelLayout::BPP16, convertGrayscale16ToRGB32, convertGrayscale16FromARGB32PM, convertGrayscale16FromRGB32, convertGrayscale16ToRGB64 }, // Format_Grayscale16
+#if Q_BYTE_ORDER == Q_BIG_ENDIAN
+    { 16, 48, 16, 32, 16, 16, 0,  0, false, QPixelLayout::BPP64, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB64ToRGB64 }, // Format_RGBX64
+    { 16, 48, 16, 32, 16, 16, 16, 0,  true, QPixelLayout::BPP64, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB64ToRGB64 } // Format_RGB64_Premultiplied
+#else
+    { 16, 0, 16, 16, 16, 32, 0,  48, false, QPixelLayout::BPP64, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB64ToRGB64 }, // Format_RGBX64
+    { 16, 0, 16, 16, 16, 32, 16, 48,  true, QPixelLayout::BPP64, convertPassThrough, convertPassThrough, convertPassThrough, convertRGB64ToRGB64 } // Format_RGB64_Premultiplied
+#endif
 };
 
 FetchPixelsFunc qFetchPixels[QPixelLayout::BPPCount] = {
     0, // BPPNone
-    fetchPixels<QPixelLayout::BPP1MSB>, // BPP1MSB
-    fetchPixels<QPixelLayout::BPP1LSB>, // BPP1LSB
-    fetchPixels<QPixelLayout::BPP8>, // BPP8
-    fetchPixels<QPixelLayout::BPP16>, // BPP16
-    fetchPixels<QPixelLayout::BPP24>, // BPP24
-    fetchPixels<QPixelLayout::BPP32> // BPP32
+    fetchPixels<QPixelLayout::BPP1MSB>,
+    fetchPixels<QPixelLayout::BPP1LSB>,
+    fetchPixels<QPixelLayout::BPP8>,
+    fetchPixels<QPixelLayout::BPP16>,
+    fetchPixels<QPixelLayout::BPP24>,
+    fetchPixels<QPixelLayout::BPP32>,
+    fetchPixels<QPixelLayout::BPP64>
 };
 
 StorePixelsFunc qStorePixels[QPixelLayout::BPPCount] = {
     0, // BPPNone
-    storePixels<QPixelLayout::BPP1MSB>, // BPP1MSB
-    storePixels<QPixelLayout::BPP1LSB>, // BPP1LSB
-    storePixels<QPixelLayout::BPP8>, // BPP8
-    storePixels<QPixelLayout::BPP16>, // BPP16
-    storePixels<QPixelLayout::BPP24>, // BPP24
-    storePixels<QPixelLayout::BPP32> // BPP32
+    storePixels<QPixelLayout::BPP1MSB>,
+    storePixels<QPixelLayout::BPP1LSB>,
+    storePixels<QPixelLayout::BPP8>,
+    storePixels<QPixelLayout::BPP16>,
+    storePixels<QPixelLayout::BPP24>,
+    storePixels<QPixelLayout::BPP32>,
+    storePixels<QPixelLayout::BPP64>
+};
+
+FetchPixelsFunc64 qFetchPixels64[QPixelLayout::BPPCount] = {
+    0, // BPPNone
+    fetchPixels64<QPixelLayout::BPP1MSB>,
+    fetchPixels64<QPixelLayout::BPP1LSB>,
+    fetchPixels64<QPixelLayout::BPP8>,
+    fetchPixels64<QPixelLayout::BPP16>,
+    fetchPixels64<QPixelLayout::BPP24>,
+    fetchPixels64<QPixelLayout::BPP32>,
+    fetchPixels64<QPixelLayout::BPP64>
+};
+
+StorePixelsFunc64 qStorePixels64[QPixelLayout::BPPCount] = {
+    0, // BPPNone
+    storePixels64<QPixelLayout::BPP1MSB>,
+    storePixels64<QPixelLayout::BPP1LSB>,
+    storePixels64<QPixelLayout::BPP8>,
+    storePixels64<QPixelLayout::BPP16>,
+    storePixels64<QPixelLayout::BPP24>,
+    storePixels64<QPixelLayout::BPP64>
 };
 
 typedef uint (QT_FASTCALL *FetchPixelFunc)(const uchar *src, int index);
+typedef quint64 (QT_FASTCALL *FetchPixelFunc64)(const uchar *src, int index);
 
 FetchPixelFunc qFetchPixel[QPixelLayout::BPPCount] = {
     0, // BPPNone
-    fetchPixel<QPixelLayout::BPP1MSB>, // BPP1MSB
-    fetchPixel<QPixelLayout::BPP1LSB>, // BPP1LSB
-    fetchPixel<QPixelLayout::BPP8>, // BPP8
-    fetchPixel<QPixelLayout::BPP16>, // BPP16
-    fetchPixel<QPixelLayout::BPP24>, // BPP24
-    fetchPixel<QPixelLayout::BPP32> // BPP32
+    fetchPixel<QPixelLayout::BPP1MSB>,
+    fetchPixel<QPixelLayout::BPP1LSB>,
+    fetchPixel<QPixelLayout::BPP8>,
+    fetchPixel<QPixelLayout::BPP16>,
+    fetchPixel<QPixelLayout::BPP24>,
+    fetchPixel<QPixelLayout::BPP32>,
+    fetchPixel<QPixelLayout::BPP64>,
+};
+
+FetchPixelFunc64 qFetchPixel64[QPixelLayout::BPPCount] = {
+    0, // BPPNone
+    fetchPixel64<QPixelLayout::BPP1MSB>,
+    fetchPixel64<QPixelLayout::BPP1LSB>,
+    fetchPixel64<QPixelLayout::BPP8>,
+    fetchPixel64<QPixelLayout::BPP16>,
+    fetchPixel64<QPixelLayout::BPP24>,
+    fetchPixel64<QPixelLayout::BPP32>,
+    fetchPixel64<QPixelLayout::BPP64>,
 };
 
 /*
@@ -1030,16 +1232,13 @@ static uint *QT_FASTCALL destFetch(uint *buffer, QRasterBuffer *rasterBuffer, in
 static QRgba64 *QT_FASTCALL destFetch64(QRgba64 *buffer, QRasterBuffer *rasterBuffer, int x, int y, int length)
 {
     const QPixelLayout *layout = &qPixelLayouts[rasterBuffer->format];
-    uint buffer32[buffer_size];
-    const uint *ptr = qFetchPixels[layout->bpp](buffer32, rasterBuffer->scanLine(y), x, length);
+    const quint64 *ptr = qFetchPixels64[layout->bpp]((quint64*)buffer, rasterBuffer->scanLine(y), x, length);
     return const_cast<QRgba64 *>(layout->convertToARGB64PM(buffer, ptr, length, layout, 0));
 }
 
-static QRgba64 *QT_FASTCALL destFetch64uint32(QRgba64 *buffer, QRasterBuffer *rasterBuffer, int x, int y, int length)
+static QRgba64 * QT_FASTCALL destFetchRGBA64P(QRgba64 *, QRasterBuffer *rasterBuffer, int x, int y, int)
 {
-    const QPixelLayout *layout = &qPixelLayouts[rasterBuffer->format];
-    const uint *src = ((const uint *)rasterBuffer->scanLine(y)) + x;
-    return const_cast<QRgba64 *>(layout->convertToARGB64PM(buffer, src, length, layout, 0));
+    return (QRgba64 *)rasterBuffer->scanLine(y) + x;
 }
 
 static DestFetchProc destFetchProc[QImage::NImageFormats] =
@@ -1069,6 +1268,9 @@ static DestFetchProc destFetchProc[QImage::NImageFormats] =
     destFetch,          // Format_A2RGB30_Premultiplied
     destFetch,          // Format_Alpha8
     destFetch,          // Format_Grayscale8
+    destFetch,          // Format_Grayscale16
+    destFetch,          // Format_RGBX64
+    destFetch,          // Format_RGBA64_Premultiplied
 };
 
 static DestFetchProc64 destFetchProc64[QImage::NImageFormats] =
@@ -1077,9 +1279,9 @@ static DestFetchProc64 destFetchProc64[QImage::NImageFormats] =
     destFetch64,        // Format_Mono,
     destFetch64,        // Format_MonoLSB
     0,                  // Format_Indexed8
-    destFetch64uint32,  // Format_RGB32
-    destFetch64uint32,  // Format_ARGB32,
-    destFetch64uint32,  // Format_ARGB32_Premultiplied
+    destFetch64,        // Format_RGB32
+    destFetch64,        // Format_ARGB32,
+    destFetch64,        // Format_ARGB32_Premultiplied
     destFetch64,        // Format_RGB16
     destFetch64,        // Format_ARGB8565_Premultiplied
     destFetch64,        // Format_RGB666
@@ -1089,15 +1291,18 @@ static DestFetchProc64 destFetchProc64[QImage::NImageFormats] =
     destFetch64,        // Format_RGB888
     destFetch64,        // Format_RGB444
     destFetch64,        // Format_ARGB4444_Premultiplied
-    destFetch64uint32,  // Format_RGBX8888
-    destFetch64uint32,  // Format_RGBA8888
-    destFetch64uint32,  // Format_RGBA8888_Premultiplied
-    destFetch64uint32,  // Format_BGR30
-    destFetch64uint32,  // Format_A2BGR30_Premultiplied
-    destFetch64uint32,  // Format_RGB30
-    destFetch64uint32,  // Format_A2RGB30_Premultiplied
+    destFetch64,        // Format_RGBX8888
+    destFetch64,        // Format_RGBA8888
+    destFetch64,        // Format_RGBA8888_Premultiplied
+    destFetch64,        // Format_BGR30
+    destFetch64,        // Format_A2BGR30_Premultiplied
+    destFetch64,        // Format_RGB30
+    destFetch64,        // Format_A2RGB30_Premultiplied
     destFetch64,        // Format_Alpha8
     destFetch64,        // Format_Grayscale8
+    destFetch64,        // Format_Grayscale16
+    destFetchRGBA64P,   // Format_RGBX64
+    destFetchRGBA64P,   // Format_RGBA64_Premultiplied
 };
 
 /*
@@ -1216,13 +1421,6 @@ static void QT_FASTCALL destStore(QRasterBuffer *rasterBuffer, int x, int y, con
     }
 }
 
-static void QT_FASTCALL convertFromRgb64(uint *dest, const QRgba64 *src, int length)
-{
-    for (int i = 0; i < length; ++i) {
-        dest[i] = src[i].toArgb32();
-    }
-}
-
 static void QT_FASTCALL destStore64(QRasterBuffer *rasterBuffer, int x, int y, const QRgba64 *buffer, int length)
 {
     uint buf[buffer_size];
@@ -1232,7 +1430,7 @@ static void QT_FASTCALL destStore64(QRasterBuffer *rasterBuffer, int x, int y, c
     while (length) {
         int l = qMin(length, buffer_size);
         const uint *ptr = 0;
-        convertFromRgb64(buf, buffer, l);
+        qConvertRGBA64ToARGB32(buf, buffer, length);
         if (!layout->premultiplied && !layout->alphaWidth)
             ptr = layout->convertFromRGB32(buf, buf, l, layout, 0);
         else
@@ -1307,6 +1505,26 @@ static void QT_FASTCALL destStore64RGB30(QRasterBuffer *rasterBuffer, int x, int
 #endif
 }
 
+static void QT_FASTCALL destStore64Gray16(QRasterBuffer *rasterBuffer, int x, int y, const QRgba64 *buffer, int length)
+{
+    quint16 *dest = (quint16*)rasterBuffer->scanLine(y) + x;
+    for (int i = 0; i < length; ++i) {
+        QRgba64 v = buffer[i].unpremultiplied();
+        // FIXME: Wrong gray conversion:
+        dest[i] = qGray(v.red(), v.green(), v.blue());
+    }
+}
+
+static void QT_FASTCALL destStore64RGB64(QRasterBuffer *rasterBuffer, int x, int y, const QRgba64 *buffer, int length)
+{
+    QRgba64 *dest = (QRgba64*)rasterBuffer->scanLine(y) + x;
+    if (dest == buffer)
+        return;
+    for (int i = 0; i < length; ++i) {
+        dest[i] = buffer[i];
+    }
+}
+
 static DestStoreProc destStoreProc[QImage::NImageFormats] =
 {
     0,                  // Format_Invalid
@@ -1334,6 +1552,9 @@ static DestStoreProc destStoreProc[QImage::NImageFormats] =
     destStore,          // Format_A2RGB30_Premultiplied
     destStore,          // Format_Alpha8
     destStore,          // Format_Grayscale8
+    destStore,          // Format_Grayscale16
+    destStore,          // Format_RGBX64
+    destStore,          // Format_RGBA64_Premultiplied
 };
 
 static DestStoreProc64 destStoreProc64[QImage::NImageFormats] =
@@ -1363,6 +1584,9 @@ static DestStoreProc64 destStoreProc64[QImage::NImageFormats] =
     destStore64RGB30<PixelOrderRGB>,        // Format_A2RGB30_Premultiplied
     destStore64,        // Format_Alpha8
     destStore64,        // Format_Grayscale8
+    destStore64Gray16,  // Format_Grayscale16
+    destStore64RGB64,   // Format_RGBX64
+    destStore64RGB64    // Format_RGBA64_Premultiplied
 };
 
 /*
@@ -1425,14 +1649,15 @@ static const QRgba64 *QT_FASTCALL fetchUntransformed64(QRgba64 *buffer, const Op
 {
     const QPixelLayout *layout = &qPixelLayouts[data->texture.format];
     const QRgb *clut = data->texture.colorTable ? data->texture.colorTable->constData() : 0;
-    if (layout->bpp != QPixelLayout::BPP32) {
-        uint buffer32[buffer_size];
-        const uint *ptr = qFetchPixels[layout->bpp](buffer32, data->texture.scanLine(y), x, length);
-        return layout->convertToARGB64PM(buffer, ptr, length, layout, clut);
-    } else {
-        const uint *src = (const uint *)data->texture.scanLine(y) + x;
-        return layout->convertToARGB64PM(buffer, src, length, layout, clut);
-    }
+    const quint64 *ptr = qFetchPixels64[layout->bpp](reinterpret_cast<quint64*>(buffer), data->texture.scanLine(y), x, length);
+    return layout->convertToARGB64PM(buffer, ptr, length, layout, clut);
+}
+
+static const QRgba64 *QT_FASTCALL fetchUntransformedRGBA64PM(QRgba64 *, const Operator *,
+                                                             const QSpanData *data, int y, int x, int)
+{
+    const uchar *scanLine = data->texture.scanLine(y);
+    return ((const QRgba64 *)scanLine) + x;
 }
 
 // blendType is either BlendTransformed or BlendTransformedTiled
@@ -1613,10 +1838,9 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
     const qreal cy = y + qreal(0.5);
 
     const QPixelLayout *layout = &qPixelLayouts[data->texture.format];
-    FetchPixelFunc fetch = qFetchPixel[layout->bpp];
+    FetchPixelFunc64 fetch = qFetchPixel64[layout->bpp];
     const QRgb *clut = data->texture.colorTable ? data->texture.colorTable->constData() : 0;
 
-    uint buffer32[buffer_size];
     QRgba64 *b = buffer;
     if (data->fast_matrix) {
         // The increment pr x in the scanline
@@ -1631,7 +1855,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
         int i = 0,  j = 0;
         while (i < length) {
             if (j == buffer_size) {
-                layout->convertToARGB64PM(b, buffer32, buffer_size, layout, clut);
+                layout->convertToARGB64PM(b, (const quint64*)b, buffer_size, layout, clut);
                 b += buffer_size;
                 j = 0;
             }
@@ -1647,14 +1871,14 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
                 px = qBound(0, px, image_width - 1);
                 py = qBound(0, py, image_height - 1);
             }
-            buffer32[j] = fetch(data->texture.scanLine(py), px);
+            b[j] = fetch(data->texture.scanLine(py), px);
 
             fx += fdx;
             fy += fdy;
             ++i; ++j;
         }
         if (j > 0) {
-            layout->convertToARGB64PM(b, buffer32, j, layout, clut);
+            layout->convertToARGB64PM(b, (const quint64*)b, j, layout, clut);
             b += j;
         }
     } else {
@@ -1669,7 +1893,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
         int i = 0,  j = 0;
         while (i < length) {
             if (j == buffer_size) {
-                layout->convertToARGB64PM(b, buffer32, buffer_size, layout, clut);
+                layout->convertToARGB64PM(b, (const quint64*)b, buffer_size, layout, clut);
                 b += buffer_size;
                 j = 0;
             }
@@ -1688,7 +1912,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
                 px = qBound(0, px, image_width - 1);
                 py = qBound(0, py, image_height - 1);
             }
-            buffer32[j] = fetch(data->texture.scanLine(py), px);
+            b[j] = fetch(data->texture.scanLine(py), px);
 
             fx += fdx;
             fy += fdy;
@@ -1700,7 +1924,7 @@ static const QRgba64 *QT_FASTCALL fetchTransformed64(QRgba64 *buffer, const Oper
             ++i; ++j;
         }
         if (j > 0) {
-            layout->convertToARGB64PM(b, buffer32, j, layout, clut);
+            layout->convertToARGB64PM(b, (const quint64*)b, j, layout, clut);
             b += j;
         }
     }
